=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpContainerClient
  class RepositoriesContainerPushApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a container push repository
    # ViewSet for a container push repository.
    # @param container_container_push_repository [ContainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [ContainerContainerPushRepositoryResponse]
    def create(container_container_push_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(container_container_push_repository, opts)
      data
    end

    # Create a container push repository
    # ViewSet for a container push repository.
    # @param container_container_push_repository [ContainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContainerContainerPushRepositoryResponse, Integer, Hash)>] ContainerContainerPushRepositoryResponse data, response status code and response headers
    def create_with_http_info(container_container_push_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.create ...'
      end
      # verify the required parameter 'container_container_push_repository' is set
      if @api_client.config.client_side_validation && container_container_push_repository.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository' when calling RepositoriesContainerPushApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/container/container-push/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_push_repository) 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerPushRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a container push repository
    # Trigger an asynchronous delete task
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(container_container_push_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(container_container_push_repository_href, opts)
      data
    end

    # Delete a container push repository
    # Trigger an asynchronous delete task
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(container_container_push_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.delete ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.delete"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List container push repositorys
    # ViewSet for a container push repository.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse2007]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List container push repositorys
    # ViewSet for a container push repository.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse2007, Integer, Hash)>] InlineResponse2007 data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/container/container-push/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse2007' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a container push repository
    # ViewSet for a container push repository.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerContainerPushRepositoryResponse]
    def read(container_container_push_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_container_push_repository_href, opts)
      data
    end

    # Inspect a container push repository
    # ViewSet for a container push repository.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerContainerPushRepositoryResponse, Integer, Hash)>] ContainerContainerPushRepositoryResponse data, response status code and response headers
    def read_with_http_info(container_container_push_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.read ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.read"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerPushRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
